diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-transmit-filter.h ns-3.41/src/spectrum/model/spectrum-transmit-filter.h
--- ns-3.40/src/spectrum/model/spectrum-transmit-filter.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-transmit-filter.h	2024-02-09 14:44:08.497794400 -0800
@@ -74,8 +74,30 @@
      */
     bool Filter(Ptr<const SpectrumSignalParameters> params, Ptr<const SpectrumPhy> receiverPhy);
 
+    /**
+     * If this loss model uses objects of type RandomVariableStream,
+     * set the stream numbers to the integers starting with the offset
+     * 'stream'. Return the number of streams (possibly zero) that
+     * have been assigned.  If there are SpectrumTransmitFilters chained
+     * together, this method will also assign streams to the
+     * downstream models.
+     *
+     * \param stream the stream index offset start
+     * \return the number of stream indices assigned by this model
+     */
+    int64_t AssignStreams(int64_t stream);
+
   protected:
     void DoDispose() override;
+    /**
+     * Assign a fixed random variable stream number to the random variables used by this model.
+     *
+     * Subclasses must implement this; those not using random variables can return zero.
+     *
+     * \param stream first stream index to use
+     * \return the number of stream indices assigned by this model
+     */
+    virtual int64_t DoAssignStreams(int64_t stream) = 0;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-value.cc ns-3.41/src/spectrum/model/spectrum-value.cc
--- ns-3.40/src/spectrum/model/spectrum-value.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-value.cc	2024-02-09 14:44:08.497794400 -0800
@@ -411,6 +411,18 @@
     return res;
 }
 
+bool
+operator==(const SpectrumValue& lhs, const SpectrumValue& rhs)
+{
+    return (lhs.m_values == rhs.m_values);
+}
+
+bool
+operator!=(const SpectrumValue& lhs, const SpectrumValue& rhs)
+{
+    return (lhs.m_values != rhs.m_values);
+}
+
 SpectrumValue
 operator+(const SpectrumValue& lhs, double rhs)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-value.h ns-3.41/src/spectrum/model/spectrum-value.h
--- ns-3.40/src/spectrum/model/spectrum-value.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-value.h	2024-02-09 14:44:08.497794400 -0800
@@ -160,6 +160,50 @@
     uint32_t GetValuesN() const;
 
     /**
+     * Directly set the values using the std::vector<double>
+     * \param values a reference to the std::vector<double>
+     */
+    inline void SetValues(Values& values)
+    {
+        NS_ASSERT_MSG(
+            values.size() == m_spectrumModel->GetNumBands(),
+            "Values size does not correspond to the SpectrumModel in use by this SpectrumValue.");
+        m_values = values;
+    }
+
+    /**
+     * Directly set the values by moving the values from the input std::vector<double>
+     * \param values a reference to the std::vector<double> to be moved
+     */
+    inline void SetValues(Values&& values)
+    {
+        NS_ASSERT_MSG(
+            values.size() == m_spectrumModel->GetNumBands(),
+            "Values size does not correspond to the SpectrumModel in use by this SpectrumValue.");
+        m_values = std::move(values);
+    }
+
+    /**
+     * \brief Provides the direct access to the underlying std::vector<double>
+     * that stores the spectrum values.
+     * \return a reference to the stored values
+     */
+    inline Values& GetValues()
+    {
+        return m_values;
+    }
+
+    /**
+     * \brief Provides the direct read-only access to the underlying std::vector<double>
+     * that stores the spectrum values.
+     * \return a const reference to the stored values
+     */
+    inline const Values& GetValues() const
+    {
+        return m_values;
+    }
+
+    /**
      * \brief Get the value element at the position
      * \param pos position
      * \return the value element in that position (with bounds checking)
@@ -287,6 +331,26 @@
     friend SpectrumValue operator/(double lhs, const SpectrumValue& rhs);
 
     /**
+     * Compare two spectrum values
+     *
+     * @param lhs Left Hand Side of the operator
+     * @param rhs Right Hand Side of the operator
+     *
+     * @return true if lhs and rhs SpectruValues are equal
+     */
+    friend bool operator==(const SpectrumValue& lhs, const SpectrumValue& rhs);
+
+    /**
+     * Compare two spectrum values
+     *
+     * @param lhs Left Hand Side of the operator
+     * @param rhs Right Hand Side of the operator
+     *
+     * @return true if lhs and rhs SpectruValues are not equal
+     */
+    friend bool operator!=(const SpectrumValue& lhs, const SpectrumValue& rhs);
+
+    /**
      * unary plus operator
      *
      * @param rhs Right Hand Side of the operator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/three-gpp-channel-model.cc ns-3.41/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.40/src/spectrum/model/three-gpp-channel-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/three-gpp-channel-model.cc	2024-02-09 14:44:08.497794400 -0800
@@ -32,6 +32,7 @@
 #include <ns3/simulator.h>
 
 #include <algorithm>
+#include <map>
 #include <random>
 
 namespace ns3
@@ -1869,8 +1870,8 @@
     // Step 11: Generate channel coefficients for each cluster n and each receiver
     //  and transmitter element pair u,s.
     // where n is cluster index, u and s are receive and transmit antenna element.
-    size_t uSize = uAntenna->GetNumberOfElements();
-    size_t sSize = sAntenna->GetNumberOfElements();
+    size_t uSize = uAntenna->GetNumElems();
+    size_t sSize = sAntenna->GetNumElems();
 
     // NOTE: Since each of the strongest 2 clusters are divided into 3 sub-clusters,
     // the total cluster will generally be numReducedCLuster + 4.
@@ -1909,9 +1910,6 @@
     Angles sAngle(uMob->GetPosition(), sMob->GetPosition());
     Angles uAngle(sMob->GetPosition(), uMob->GetPosition());
 
-    Complex2DVector raysPreComp(channelParams->m_reducedClusterNumber,
-                                table3gpp->m_raysPerCluster); // stores part of the ray expression,
-    // cached as independent from the u- and s-indexes
     Double2DVector sinCosA; // cached multiplications of sin and cos of the ZoA and AoA angles
     Double2DVector sinSinA; // cached multiplications of sines of the ZoA and AoA angles
     Double2DVector cosZoA;  // cached cos of the ZoA angle
@@ -1919,6 +1917,18 @@
     Double2DVector sinSinD; // cached multiplications of the cosines of the ZoA and AoA angles
     Double2DVector cosZoD;  // cached cos of the ZoD angle
 
+    // contains part of the ray expression, cached as independent from the u- and s-indexes,
+    // but calculate it for different polarization angles of s and u
+    std::map<std::pair<uint8_t, uint8_t>, Complex2DVector> raysPreComp;
+    for (size_t polSa = 0; polSa < sAntenna->GetNumPols(); ++polSa)
+    {
+        for (size_t polUa = 0; polUa < uAntenna->GetNumPols(); ++polUa)
+        {
+            raysPreComp[std::make_pair(polSa, polUa)] =
+                Complex2DVector(channelParams->m_reducedClusterNumber, table3gpp->m_raysPerCluster);
+        }
+    }
+
     // resize to appropriate dimensions
     sinCosA.resize(channelParams->m_reducedClusterNumber);
     sinSinA.resize(channelParams->m_reducedClusterNumber);
@@ -1946,21 +1956,30 @@
 
             // cache the component of the "rays" terms which depend on the random angle of arrivals
             // and departures and initial phases only
-            auto [rxFieldPatternPhi, rxFieldPatternTheta] = uAntenna->GetElementFieldPattern(
-                Angles(channelParams->m_rayAoaRadian[nIndex][mIndex],
-                       channelParams->m_rayZoaRadian[nIndex][mIndex]));
-            auto [txFieldPatternPhi, txFieldPatternTheta] = sAntenna->GetElementFieldPattern(
-                Angles(channelParams->m_rayAodRadian[nIndex][mIndex],
-                       channelParams->m_rayZodRadian[nIndex][mIndex]));
-            raysPreComp(nIndex, mIndex) =
-                std::complex<double>(cos(initialPhase[0]), sin(initialPhase[0])) *
-                    rxFieldPatternTheta * txFieldPatternTheta +
-                std::complex<double>(cos(initialPhase[1]), sin(initialPhase[1])) *
-                    std::sqrt(1.0 / k) * rxFieldPatternTheta * txFieldPatternPhi +
-                std::complex<double>(cos(initialPhase[2]), sin(initialPhase[2])) *
-                    std::sqrt(1.0 / k) * rxFieldPatternPhi * txFieldPatternTheta +
-                std::complex<double>(cos(initialPhase[3]), sin(initialPhase[3])) *
-                    rxFieldPatternPhi * txFieldPatternPhi;
+            for (uint8_t polUa = 0; polUa < uAntenna->GetNumPols(); ++polUa)
+            {
+                auto [rxFieldPatternPhi, rxFieldPatternTheta] = uAntenna->GetElementFieldPattern(
+                    Angles(channelParams->m_rayAoaRadian[nIndex][mIndex],
+                           channelParams->m_rayZoaRadian[nIndex][mIndex]),
+                    polUa);
+                for (uint8_t polSa = 0; polSa < sAntenna->GetNumPols(); ++polSa)
+                {
+                    auto [txFieldPatternPhi, txFieldPatternTheta] =
+                        sAntenna->GetElementFieldPattern(
+                            Angles(channelParams->m_rayAodRadian[nIndex][mIndex],
+                                   channelParams->m_rayZodRadian[nIndex][mIndex]),
+                            polSa);
+                    raysPreComp[std::make_pair(polSa, polUa)](nIndex, mIndex) =
+                        std::complex<double>(cos(initialPhase[0]), sin(initialPhase[0])) *
+                            rxFieldPatternTheta * txFieldPatternTheta +
+                        std::complex<double>(cos(initialPhase[1]), sin(initialPhase[1])) *
+                            std::sqrt(1.0 / k) * rxFieldPatternTheta * txFieldPatternPhi +
+                        std::complex<double>(cos(initialPhase[2]), sin(initialPhase[2])) *
+                            std::sqrt(1.0 / k) * rxFieldPatternPhi * txFieldPatternTheta +
+                        std::complex<double>(cos(initialPhase[3]), sin(initialPhase[3])) *
+                            rxFieldPatternPhi * txFieldPatternPhi;
+                }
+            }
 
             // cache the component of the "rxPhaseDiff" terms which depend on the random angle of
             // arrivals only
@@ -2011,10 +2030,11 @@
                             2 * M_PI *
                             (sinCosD[nIndex][mIndex] * sLoc.x + sinSinD[nIndex][mIndex] * sLoc.y +
                              cosZoD[nIndex][mIndex] * sLoc.z);
-
                         // NOTE Doppler is computed in the CalcBeamformingGain function and is
                         // simplified to only account for the center angle of each cluster.
-                        rays += raysPreComp(nIndex, mIndex) *
+                        rays += raysPreComp[std::make_pair(sAntenna->GetElemPol(sIndex),
+                                                           uAntenna->GetElemPol(uIndex))](nIndex,
+                                                                                          mIndex) *
                                 std::complex<double>(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
                                 std::complex<double>(cos(txPhaseDiff), sin(txPhaseDiff));
                     }
@@ -2043,7 +2063,9 @@
                              cosZoD[nIndex][mIndex] * sLoc.z);
 
                         std::complex<double> raySub =
-                            raysPreComp(nIndex, mIndex) *
+                            raysPreComp[std::make_pair(sAntenna->GetElemPol(sIndex),
+                                                       uAntenna->GetElemPol(uIndex))](nIndex,
+                                                                                      mIndex) *
                             std::complex<double>(cos(rxPhaseDiff), sin(rxPhaseDiff)) *
                             std::complex<double>(cos(txPhaseDiff), sin(txPhaseDiff));
 
@@ -2123,9 +2145,11 @@
                      cosSAngleIncl * sLoc.z);
 
                 auto [rxFieldPatternPhi, rxFieldPatternTheta] = uAntenna->GetElementFieldPattern(
-                    Angles(uAngle.GetAzimuth(), uAngle.GetInclination()));
+                    Angles(uAngle.GetAzimuth(), uAngle.GetInclination()),
+                    uAntenna->GetElemPol(uIndex));
                 auto [txFieldPatternPhi, txFieldPatternTheta] = sAntenna->GetElementFieldPattern(
-                    Angles(sAngle.GetAzimuth(), sAngle.GetInclination()));
+                    Angles(sAngle.GetAzimuth(), sAngle.GetInclination()),
+                    sAntenna->GetElemPol(sIndex));
 
                 ray = (rxFieldPatternTheta * txFieldPatternTheta -
                        rxFieldPatternPhi * txFieldPatternPhi) *
